/*************************************************************************
							16-Dec-94




		Polhemus Inc.
		A Kaiser Aerospace & Electronics Company
		P.O. Box 560
		Colchester, Vermont 05446
		(802) 655-3159



	Program			ULTRA-TRAK: trackio.Cpp
				InsideTRAK Interface


		Version	1.00	CPG6169-002-01
	     Copyright POLHEMUS 1994-1995 ALL RIGHTS RESERVED


	The purpose of this program is to process commands in the user
	interface to the ultra-trak.
*************************************************************************
Change History		Change History		Change History
17Mar95		SST
	Cleaned up commandBoard and commandAll
*************************************************************************

************************************************************************
			Include Files
************************************************************************/
#include <dos.h>
#include <string.h>
#include <conio.h>
#include "trackio.h"

/************************************************************************
function	output_to_tracker

purpose		Write a count of data to the indicated port
		This shall replace the routine in the track program,
		subject to additional modifications.

inputs		port of output board	[modified from trak.c]
		command_data pointer
		number of characters

description	Output an array of data to the bus

outputs

*************************************************************************/
void	output_to_tracker(int bus_ADDR, char *cbuf, int nbr_chro)
{
int i, ib;

for(i=0;i<nbr_chro;i++)
	{
    ib=inpw(bus_ADDR|1);
	if( (ib&2) == 0)	/* test for full == bit 1 */
		{
		delay(0);	// This isn't supposed to happen!
		}

	outportb(bus_ADDR, cbuf[i]);
	}
}

/************************************************************************
function	capture_tracker

purpose		call principal functions

inputs		ISA bus address
		Insidetrak outputs

description	used for board status number of captured words

outputs		record of incoming data
		indicator of which FTK is coming

************************************************************************/
int capture_tracker(unsigned int *trakrec, int Baddr)
{
int i,
	bsts;

bsts = inp(Baddr|1);
					/* data available == bit 0 */
for(i=0; (bsts &1)&& i < 512; bsts = inp(Baddr|1), i++) 
	trakrec[i] = inpw(Baddr);
return i;
}

